//Archer Include

namespace ArcherParams
{
enum Aim {
    not_aiming = 0,
    readying,
    charging,
    decharging,
    fired,
    no_arrows,
	stabbing
}

const ::s32 ready_time = 15;
const ::s32 shoot_period = 62;
const ::s32 fired_time = 7;
const ::f32 shoot_max_vel = 19.59f;
}

namespace ArrowType
{
enum type
{
    normal = 0,
    fire,
	bomb,
	water,
	count
};
}

shared class ArcherInfo
{
	s8 charge_time;
	u8 charge_state;
	bool has_arrow;
	u8 stab_delay;
	u8 fletch_cooldown;
	u8 arrow_type;
}

const string[] arrowTypeNames = { "mat_arrows",
                                  "mat_firearrows",
								  "mat_bombarrows",
								  "mat_waterarrows"
                                };
const string[] arrowNames = { "Regular arrows",
                              "Fire arrows",
							  "Bomb arrow",
							  "Water arrows"
                            };

const string[] arrowIcons = { "$Arrow$",
							  "$FireArrow$",
							  "$BombArrow$",
							  "$WaterArrow$"
};


bool hasArrows( CBlob@ this )
{
	ArcherInfo@ archer;
	if (!this.get( "archerInfo", @archer )) {
		return false;

	}
	if (archer.arrow_type >= 0 && archer.arrow_type < arrowTypeNames.length) {
		return this.getBlobCount( arrowTypeNames[archer.arrow_type] ) > 0;
	}

	return false;
}

bool hasArrows( CBlob@ this, u8 arrowType )
{
	return this.getBlobCount( arrowTypeNames[arrowType] ) > 0;
}

void SetArrowType( CBlob@ this, const u8 type )
{
	ArcherInfo@ archer;
	if (!this.get( "archerInfo", @archer )) {
		return;

	}		  	
	archer.arrow_type = type;
}

u8 getArrowType( CBlob@ this )
{
	ArcherInfo@ archer;
	if (!this.get( "archerInfo", @archer )) {
		return 0;

	}						 
	return archer.arrow_type;
}